#include "MQPlugin.h"
#include "MQBasePlugin.h"
#include <unordered_map>

#ifndef _MainClass
#define _MainClass

#define STORENUM 4

class FixVertex : public MQStationPlugin
{
public:
	friend class FixVertexWindow;

	FixVertex();
	virtual ~FixVertex();

	// vOCIDԂB
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// vOCԂB
	virtual const char *GetPlugInName(void);
	// |bvAbvj[ɕ\镶ԂB
	virtual const char *EnumString(void);

	// AvP[V̏
	virtual BOOL Initialize();
	// AvP[V̏I
	virtual void Exit();

	// \E\؂ւv
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// \E\Ԃ̕ԓ
	virtual BOOL IsActivated(MQDocument doc);

	virtual void OnEndDocument(MQDocument doc);
	virtual void OnDraw(MQDocument doc_, MQScene scene, int width, int height);
//	virtual void OnUpdateObjectList(MQDocument doc);

	typedef bool (FixVertex::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

	void setFixMode(int i, int mode) { m_fixmode[i] = mode; }
	int getFixMode(int i) { return m_fixmode[i]; }
	int getFiexedVertexNum(int i) { return m_fixedvertex[i].size(); }

protected:
	struct CallbackInfo
	{
		ExecuteCallbackProc proc;
	};

	// R[obNɑ΂
	virtual bool ExecuteCallback(MQDocument doc, void *option);

private:
	FixVertexWindow *m_Window;
	bool m_bActivate;
	bool m_isfix[STORENUM]; // Œ蒆tO
	std::unordered_map<UINT, std::unordered_map<UINT, MQPoint>> m_fixedvertex[STORENUM]; // Œ蒸_
	int m_fixmode[STORENUM]; // Œ胂[h

	static const float delta;

	bool fix(MQDocument doc, int index, bool isfix);
	bool setselected(MQDocument doc, int index, bool isfix, bool isappend);
	void clear(MQDocument doc, int index);
	void clear();
};

#endif
