#include <windows.h>

#include "FixVertexWindow.h"
#include "FixVertex.h"

FixVertexWindow::FixVertexWindow(FixVertex *plugin, MQWindowBase& parent) : MQWindow(parent), m_pPlugin(plugin)
{
	SetTitle(L"FixVertex");
	SetInSpace(0.0);
	SetOutSpace(0.0);
	SetHorzLayout(LAYOUT_AUTO);
	SetVertLayout(LAYOUT_AUTO);

	MQFrame *frame1 = CreateHorizontalFrame(this);

	m_buttonfix[0] = CreateButton(frame1, L"X0");
	m_buttonfix[0]->AddLeftDownEvent(this, &FixVertexWindow::fix);
	m_buttonfix[0]->AddRightDownEvent(this, &FixVertexWindow::mode);
	m_buttonfix[0]->SetDown(false);
	for(int i = 1; i < STORENUM; i++) {
		wchar_t str[2];
		wsprintf(str, L"%d", i);
		m_buttonfix[i] = CreateButton(frame1, str);
		m_buttonfix[i]->AddLeftDownEvent(this, &FixVertexWindow::fix);
		m_buttonfix[i]->AddRightDownEvent(this, &FixVertexWindow::mode);
		m_buttonfix[i]->SetDown(false);
	}

	AddHideEvent(this, &FixVertexWindow::OnHide);
}

FixVertexWindow::~FixVertexWindow()
{
}

BOOL FixVertexWindow::OnHide(MQWidgetBase *sender, MQDocument doc)
{
	if(m_pPlugin->m_bActivate) {
		m_pPlugin->m_bActivate = false;
		m_pPlugin->WindowClose();
	}
	return FALSE;
}

BOOL FixVertexWindow::fix(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam& param)
{
	for(int i = 0; i < STORENUM; i++) {
		if(sender == m_buttonfix[i]) {
			if(param.Ctrl) {
				if(i == 0) {
					// X0{^̏ꍇ͑SŒ胂[h
					m_pPlugin->setFixMode(i, 0x7);
					break;
				}
				if (m_pPlugin->getFiexedVertexNum(i) > 0) {
					MQDialog::DIALOG_RESULT result = MQDialog::MessageOkCancelBox(*this, L"Overwrite?", L"FixVertex");
					if (result != MQDialog::DIALOG_OK) {
						return FALSE;
					}
				}
				bool isfix = m_pPlugin->setselected(doc, i, true, true);
				m_buttonfix[i]->SetDown(isfix);
			}
			else if(param.Shift) {
				if(i == 0) {
					// X0{^̏X̂݌Œ胂[h
					m_pPlugin->setFixMode(i, 0x1);
					break;
				}
				if (m_pPlugin->getFiexedVertexNum(i) > 0) {
					MQDialog::DIALOG_RESULT result = MQDialog::MessageOkCancelBox(*this, L"Clear?", L"FixVertex");
					if (result != MQDialog::DIALOG_OK) {
						return FALSE;
					}
				}
				m_pPlugin->clear(doc, i);
				m_buttonfix[i]->SetDown(false);
				
			}
			else {
				bool isfix = m_buttonfix[i]->GetDown();
				isfix = m_pPlugin->fix(doc, i, !isfix);
				m_buttonfix[i]->SetDown(isfix);
			}
		}
	}
	return FALSE;
}

BOOL FixVertexWindow::mode(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam& param)
{
	for(int i = 0; i < STORENUM; i++) {
		if(sender == m_buttonfix[i]) {
			int mode = m_pPlugin->getFixMode(i);
			if(!callDialog(i, mode, param.ScreenPos)) {
				return FALSE;
			}
			m_pPlugin->setFixMode(i, mode);
		}
	}
	return FALSE;
}

void FixVertexWindow::clear()
{
	for(int i = 0; i < STORENUM; i++) {
		m_buttonfix[i]->SetDown(false);
	}
}

BOOL FixVertexWindow::callDialog(int i, int &mode, const POINT &pos)
{
	FixVertexModeDialog dlg(*this, m_pPlugin, mode);
	dlg.SetPosX(pos.x);
	dlg.SetPosY(pos.y);
	dlg.Execute();
	int modex = (dlg.m_buttonX->GetDown() ? 0x0 : 0x1);
	int modey = (dlg.m_buttonY->GetDown() ? 0x0 : 0x2);
	int modez = (dlg.m_buttonZ->GetDown() ? 0x0 : 0x4);
	mode = modex | modey | modez;
	return TRUE;
}

FixVertexModeDialog::FixVertexModeDialog(MQWindowBase& parent, FixVertex *plugin, int mode) : MQDialog(parent), m_pPlugin(plugin)
{
	setlocale(LC_CTYPE, "");
	SetTitle(L"SetFixMode");
	this->SetOutSpace(0.0);
	this->SetInSpace(0.0);

	MQFrame *frame1 = CreateHorizontalFrame(this);
	m_buttonX = CreateButton(frame1, L"X");
	m_buttonX->SetDown(!(mode & 0x1));
	m_buttonX->AddLeftDownEvent(this, &FixVertexModeDialog::clickmode);
	m_buttonX->AddRightDownEvent(this, &FixVertexModeDialog::clickother);

	m_buttonY = CreateButton(frame1, L"Y");
	m_buttonY->SetDown(!(mode & 0x2));
	m_buttonY->AddLeftDownEvent(this, &FixVertexModeDialog::clickmode);
	m_buttonY->AddRightDownEvent(this, &FixVertexModeDialog::clickother);

	m_buttonZ = CreateButton(frame1, L"Z");
	m_buttonZ->SetDown(!(mode & 0x4));
	m_buttonZ->AddLeftDownEvent(this, &FixVertexModeDialog::clickmode);
	m_buttonZ->AddRightDownEvent(this, &FixVertexModeDialog::clickother);

	this->AddLeftDownEvent(this, &FixVertexModeDialog::clickmode);
	this->AddRightDownEvent(this, &FixVertexModeDialog::clickother);
	this->AddKeyDownEvent(this, &FixVertexModeDialog::keyevent);
}

BOOL FixVertexModeDialog::clickmode(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam &param)
{
	MQButton *button = dynamic_cast<MQButton*>(sender);
	if(button) {
		button->SetDown(!button->GetDown());
	}
	return TRUE;
}

BOOL FixVertexModeDialog::clickother(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam &param)
{
	if(param.RButton) {
		this->Close(DIALOG_OK);
	}
	return  FALSE;
}

BOOL FixVertexModeDialog::keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam &param)
{
	switch(param.Key) {
	case 0x1B: this->Close(DIALOG_OK); return TRUE;
	case 0x58: m_buttonX->SetDown(!m_buttonX->GetDown()); this->Close(DIALOG_OK); return TRUE;
	case 0x59: m_buttonY->SetDown(!m_buttonX->GetDown()); this->Close(DIALOG_OK); return TRUE;
	case 0x5A: m_buttonZ->SetDown(!m_buttonX->GetDown()); this->Close(DIALOG_OK); return TRUE;
	}
	return FALSE;
}
